-- Copyright 2018, Visions
-- All rights reserved

-- Redistribution and use in source and binary forms, with or without
-- modification, are permitted provided that the following conditions are met:

    -- * Redistributions of source code must retain the above copyright
      -- notice, this list of conditions and the following disclaimer.
    -- * Redistributions in binary form must reproduce the above copyright
      -- notice, this list of conditions and the following disclaimer in the
      -- documentation and/or other materials provided with the distribution.
    -- * Neither the name of InfoReplacer nor the
      -- names of its contributors may be used to endorse or promote products
      -- derived from this software without specific prior written permission.

-- THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
-- ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
-- WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
-- DISCLAIMED. IN NO EVENT SHALL Cairthenn BE LIABLE FOR ANY
-- DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
-- (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
-- LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
-- ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
-- (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
-- SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

--
--Realms of Jova のオリジナルメッセージを日本語化する
--


_addon.author = 'Visions'
_addon.name = 'e2j'
_addon.version = '0.94'
_addon.command = 'e2j'

defaults = {}
defaults.lfadjust = 1

e2j_debug = 0
url_pre = "http://www.ffxi-realmsofjova.ga/gas_wrap.php?url="
config = require('config')
settings = config.load(defaults)

m = {}

-------------------------------------------------------------------------------

function inc_text(original,modified,original_mode,modified_mode,blocked)

	if ( e2j_debug >= 1 ) then print("** Mode: " .. original_mode , "Text: '" .. trim1(original) .."'") end

	if ( S{9,200,13,121,214,10,206}[tonumber(original_mode)] )  then
			--9:カスタムNPCの発言っぽい？
			--200:システムメッセージ
			--13:図書館 レリミシエンピ売りのお姉さん
			--121:アイテム交換後の黄色っぽいメッセージ
			--214:ログイン、NM討伐メッセージ
			--206:/echo、テスト用

		local timestamp = ""
		local npcname = "" 
		local s, e
		local translateflg = 0
		
		-- Timestampアドオンへの対応
		s,e = modified:find("%[%d+:%d+:%d+%]")
		if s ~= nil then timestamp = modified:sub(s,e) .. " " end
	
		-- 発言者名の抽出
		s,e = original:find("^[a-zA-Z%-0-9 ]-: ")
		if s ~= nil then
			if e < 30 and s > 0 then npcname = original:sub(s,e) end
		end
	
		-- 翻訳データとの突合
		mes = original
		--if npcname ~= "" then mes = mes:gsub(npcname,"") end
		if npcname ~= "" then mes = mes:sub(e,1000) end	--npcnameにパターンマッチに使われる文字が入ると正しく置き換えられないため
		mes = trim1(mes)
		if ( e2j_debug >= 1 ) then print("** npcname: '"..npcname.."'","text: '"..mes.."'") end
		
		firstline = 0
		result = modified

		local fulltext = trim1(original)
		if m[fulltext] ~= nil then	--まず発言者名も含めて、最後の改行だけを除いたメッセージとの完全一致を確認する
			translateflg = 1
			if ( m[fulltext] == "" ) then
			elseif ( m[fulltext] == " " or m[fulltext] == "　" ) then	--半角、全角スペースひとつの時は発言させない
				pattern = "^.*" .. fulltext:gsub("[(%*%+%-%?%%%^%$%(%)%[%]%.)]","%%%1")
				result = result:gsub(pattern,"")
				result = trim1(result)
			else
				pattern = fulltext:gsub("[(%*%+%-%?%%%^%$%(%)%[%]%.)]","%%%1")
				result = result:gsub(pattern,windower.to_shift_jis(m[fulltext]))	
			end
			
		else
			mess = split(mes,"\n")	--メッセージ中に改行が含まれる場合は、改行で区切って翻訳データと突合
			for k,v in pairs(mess) do
			
	 			if ( e2j_debug >= 2 ) then print("Text: '" .. v .. "'" ) end
	 
	 			if m[v] ~= nil then
	 				--完全一致の場合
	 				
					if ( e2j_debug >= 2 ) then print("Perfect Match! pattern: " .. v:gsub('\n','\\\\n')) end
					if ( e2j_debug >= 2 ) then print("replace:'"..m[v].."'") end

	 				translateflg = 1
	 				if ( m[v] == "" ) then
	 				elseif ( m[v] == " " or m[v] == "　" ) then	--半角、全角スペースひとつの時は発言させない
	 					pattern = "^.*" .. v:gsub("[(%*%+%-%?%%%^%$%(%)%[%]%.)]","%%%1")
						result = result:gsub(pattern,"")
						result = trim1(result)
	 				else
	 					pattern = v:gsub("[(%*%+%-%?%%%^%$%(%)%[%]%.)]","%%%1")
						result = result:gsub(pattern,windower.to_shift_jis(m[v]))	
					end
				else
					--完全一致しなかった場合は、部分一致を試す
					for k_reg,v_reg in pairs(m_reg) do
						--全ての部分一致データを試す

						--いったん全ての制御文字を%でエスケープ
						pattern = k_reg:gsub("([%*%+%-%?%%%^%$%(%)%[%]%.])","%%%1")
						pattern = pattern:gsub("<%%%.%%%+>","([^\n]+)")	-- <.+>と入力されていたマッチ指定を、本来のマッチ指定に置き換える
																	-- 2018.10.7 Ver.0.9 修正 変数に改行が含まれてしまう
																	
						if ( e2j_debug >= 3 ) then print("pattern: " .. pattern:gsub('\n','\\\\n')) end
					
						if ( trim1(v):find("^" .. pattern .. "$") ) then	--resut=modifiedにはTimestamp等の出力が含まれるためオリジナルメッセージと比較する
							--マッチした場合は置き換えをしてループを抜ける
							if ( e2j_debug >= 2 ) then print("Reg Match! pattern: " .. pattern:gsub('\n','\\\\n')) end
							if ( e2j_debug >= 2 ) then print("replace:'"..v_reg.."'") end

							
							translateflg = 1
							if ( v_reg == "" ) then
							elseif ( m[v] == " " or m[v] == "　" ) then	--半角、全角スペースひとつの時は発言させない
								pattern = "^.*" .. pattern
								result = result:gsub(pattern,"")
								result = trim1(result)
							else
								result = result:gsub(pattern,windower.to_shift_jis(v_reg))
							end
							break
						end
					end
				end
			end
		end

		if ( translateflg == 1 ) then
			--改行位置の調整
			if ( settings.lfadjust == 1 ) then
				if ( result:find("\n") ~= nil ) then
					local indent_count = npcname:len()
					if ( timestamp:len() > 0 ) then indent_count = indent_count + timestamp:len() +1 end 
					if indent_count < 0 then indent_count = 0 end
					
					if ( e2j_debug >= 2 ) then print("indent_count: " .. indent_count) end --debug
					
					local indent = ""
					for i=1,indent_count do
						indent = indent .. " " 
					end
					result = trim1(result)
					result = result:gsub("\n","\n" .. indent) 
				end
			end
		end
--		if ( translateflg == 1 ) then
--			windower.add_to_chat(original_mode,result)
--			return(result)
--		end
		return(result)
	end
end

function trim1(s)
   return (s:gsub("^%s*(.-)%s*$", "%1"))
end

function split(str, delim)
    -- Eliminate bad cases...
    if string.find(str, delim) == nil then
        return { str }
    end

    local result = {}
    local pat = "(.-)" .. delim .. "()"
    local lastPos
    for part, pos in string.gfind(str, pat) do
        table.insert(result, part)
        lastPos = pos
    end
    table.insert(result, string.sub(str, lastPos))
    return result
end


windower.register_event("addon command", function(command,arg1,arg2)

	if command == 'help' then
		local t = {}
		t[#t+1] = "e2j - FF11テキスト翻訳アドオン" 
		t[#t+1] = "  <コマンド>" 
		t[#t+1] = "     //e2j LFadjust  :改行位置調節機能をON/OFFする" 
		t[#t+1] = "     //e2j update    :Webから翻訳辞書をダウンロード" 
		t[#t+1] = "     //e2j reload    :翻訳辞書を再読み込み"
		t[#t+1] = "　"
		t[#t+1] = "  <複数の辞書の読み込み>"
		t[#t+1] = "     addon/e2j/data/setting.xmlで読み込む辞書を設定できます。"
		t[#t+1] = "     RoJのみ、Vallhalaのみ、両方、またオリジナルの辞書も設定可能です。"
		t[#t+1] = "     詳しくはreadme.mdを参照してください。"
		t[#t+1] = "　"
		
		for tk,tv in pairs(t) do
			windower.add_to_chat(207, windower.to_shift_jis(tv))
		end

	elseif command == 'LFadjust' then
		if settings.lfadjust == 1 then
			settings.lfadjust = 0
			windower.add_to_chat(207, windower.to_shift_jis("e2j: 改行位置調整をOFF"))
		else
			settings.lfadjust = 1
			windower.add_to_chat(207, windower.to_shift_jis("e2j: 改行位置調整をON"))
		end

	elseif command == 'reload' then
		reloadDic()
		print"e2j: Reload dictionary."

	elseif command == 'update' then

		updateDic()
		
	elseif command == 'debug' then
		local debuglevel = arg1 or 1
		e2j_debug = tonumber(debuglevel)
		print( "e2j: debug " .. e2j_debug )
	
	elseif command == 'test' and arg1 ~= nil then
		--original,modified,original_mode,modified_mode,blocked
		print("e2j test",arg2)
		inc_text(arg2,arg2,arg1,arg1,false)
	end
	
	config.save(settings)
end)

function updateDic()
	-- スプレッドシートから辞書データを取得してdict.luaに保存
	print"e2j: Update dictionary."
	local http = require ("socket.http")
	local k,v,f,r,c,h
	for k,v in pairs(settings.dict) do
		if v ~= "test" then
			r,c,h = http.request(url_pre .. v)
			local f = io.open(windower.addon_path .. "dict_" .. k .. ".lua", "w")
			f:write(r)
			io.close(f)
		end
	end

	reloadDic()
end

function reloadDic()
	m = {}
	m_reg = {}
	
	local k,v,k2,v2
	for k,v in pairs(settings.dict) do
		local f = io.input(windower.addon_path .. "dict_" .. k .. ".lua")
		while true do
			text = f:read()
			if text == nil then break end
			eval(text)
		end
		
		for k2,v2 in pairs(_gas_wrap) do
			if ( k2:find("<%.%+>") ) then
				m_reg[k2] = v2
			else
				m[k2] = v2
			end
		end
		io.close(f)
	end
end
function eval(inStr)
    return assert(loadstring(inStr))()
end

function printFF11( text )
	windower.add_to_chat(207, windower.to_shift_jis(text))
end

--windower.register_event('load', function() updateDic() end)
windower.register_event('unload', function() end)
windower.register_event('incoming text',inc_text)
